/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.datei;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.datei.boundary.AbstractDateiExportSearchParameters;
import de.ivu.elect.business.datei.boundary.DateiExportChangeEvent;
import de.ivu.elect.business.datei.boundary.DateiExportConversationStore;
import de.ivu.elect.business.datei.boundary.DateiExportExtendedDAO;
import de.ivu.elect.business.datei.boundary.DateiExportSearch;
import de.ivu.elect.business.datei.boundary.DateiExportSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.datei.entity.DateiExport;
import de.ivu.elect.business.datei.entity.DateiExportMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractDateiExportSearchView.COMPONENT_NAME)
@View(viewId = AbstractDateiExportSearchView.VIEW_ID, useCase = UseCasePermission.DATEI_EXPORT_SEARCH)
public abstract class AbstractDateiExportSearchView extends AbstractElectSearchView<DateiExport> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "dateiExportSearchView";
  
  public static final String VIEW_ID = "/datei/datei-export-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractDateiExportSearchView requestHandler;

  @Inject
  private transient DateiExportExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(DateiExportConversationStore.class)
  protected transient DateiExportConversationStore conversationStore;

  @Inject
  protected transient DateiExportSearch search;

  @Inject
  @ConversationGroup(AbstractDateiExportSearchParameters.class)
  protected transient DateiExportSearchParameters searchParameters;

  @Inject
  protected transient DateiExportMeta entityMeta;

  public AbstractDateiExportSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public DateiExport getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(DateiExport entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public DateiExportSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<DateiExport> getEagerLoadingCollector() {
    return EagerLoadingCollector.<DateiExport> create();
  }

  @Override
  public List<DateiExport> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<DateiExport> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onDateiExportChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) DateiExportChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractDateiExportSearchView {

    @View
    @Inject
    private transient Instance<AbstractDateiExportSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractDateiExportSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
